<?php
defined('BASEPATH') or exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|    example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|    https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|    $route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|    $route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|    $route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:    my-controller/index    -> my_controller/index
|        my-controller/my-method    -> my_controller/my_method
 */
$route['default_controller'] = 'Home'; //Testing Done
$route['404_override'] = 'Home/not_found'; //Testing Done

//HomeController routes
$route['login'] = 'Home/validate_login'; // d
$route['logout'] = 'Home/logout'; // d
$route['forgot-password'] = 'Home/forgotPassword'; // d
$route['reset-password'] = 'Home/resetPassword'; // d
$route['password-update'] = 'Home/passwordUpdate'; // d
$route['master-login'] = 'Home/masterLogin'; // d

//UsersController routes

$route['fetch-user'] = 'UsersController/fetchUser'; // d
$route['profile'] = 'UsersController/profile'; //  d
$route['change-email'] = 'UsersController/changeEmail'; //d
$route['disable-account'] = 'UsersController/disableAccount'; //  d
$route['delete-account'] = 'UsersController/deleteAccount'; // d
$route['edit-client-account'] = 'UsersController/editClientAccount'; //  d
$route['create-client'] = 'UsersController/clientAccount'; // d
$route['fetch-clients'] = 'UsersController/fetchClientAccount'; // d
$route['delete-client'] = 'UsersController/deleteClient'; // d
$route['download-user-data'] = 'UsersController/downloadAllData'; // d
$route['add-reseller'] = 'UsersController/reseller'; // d
$route['delete-reseller'] = 'UsersController/deleteRowsResellerAccount'; //  d
$route['fetch-reseller'] = 'UsersController/fetchResellerAccounts'; // d
$route['update-reseller'] = 'UsersController/editReseller'; //  d
$route['wl-rebranding'] = 'UsersController/WLRebranding'; // d
$route['delete-wl'] = 'UsersController/deleteWL'; // d
$route['fetch-wl-rebranding'] = 'UsersController/fetchWLRebranding'; //
$route['update-profile-image'] = 'UsersController/changeProfileImage';
$route['upload-file'] = 'UsersController/file_upload';

/**
 * JvZooIpnController controller
 */
$route['inp'] = 'JvZooIpnController/index';

//SuperAdminController

$route['api/fetch-users'] = 'SuperAdminController/fetchUsers';
$route['api/fetch-user'] = 'SuperAdminController/fetchUser';
$route['api/add-user'] = 'SuperAdminController/addUser';
$route['api/delete-user'] = 'SuperAdminController/deleteUser';
$route['api/disable-user'] = 'SuperAdminController/disableUser';
$route['api/suspend-user'] = 'SuperAdminController/suspendUser';
$route['api/update-password'] = 'SuperAdminController/updatePassword';
$route['api/change-email'] = 'SuperAdminController/updateEmail';
$route['api/check-user'] = 'SuperAdminController/checkUser';
$route['api/fetch-user-campaign'] = 'SuperAdminController/fetchUserCampaign';
$route['api/update-details'] = 'SuperAdminController/updateUserDetails';
$route['api/suspected_users'] = 'SuperAdminController/suspected_users';
$route['api/filter-data'] = 'SuperAdminController/filter_data';
$route['api/whitelist-Email'] = 'SuperAdminController/whitelist_Email';
$route['add-bulk-user'] = 'SuperAdminController/createBulkAccount';

//CategoryController

$route['fetch-category'] = 'CategoryController/fetchAllCategory';

//TaskController

$route['fetch-task'] = 'TaskController/fetchAllTask';
$route['fetch-popular-task'] = 'TaskController/fetchPopularTask';
$route['search-task'] = 'TaskController/searchTask';

//CategoryController

$route['generate-project'] = 'ProjectController/createProject';
$route['fetch-project'] = 'ProjectController/fetchProject';
$route['save-project'] = 'ProjectController/updateProject';
$route['generate-script'] = 'ProjectController/generateScript';
$route['fetch-all-project'] = 'ProjectController/fetchAllProject';
$route['delete-project'] = 'ProjectController/deleteProject';

// generate Image pass prompt

$route['generate-image'] = 'GenerateImageController/generateImage';
