<?php
date_default_timezone_set("Asia/Calcutta");

class ProjectController extends CI_Controller
{

    public function __construct()
    {

        parent::__construct();
        $verify_token = $this->jwt_verify->verify_token_2();
        if ($verify_token['status'] != false) {
            $this->user_id = $verify_token['data']['user_id'];

            $user = $this->DatabaseModel->fetchTableData('users', array('id' => $this->user_id));

            if (!empty($user[0]->parent) && !empty($user[0]->isClient)) {

                $this->clientId = $user[0]->id;
                $this->user_id = $user[0]->parent;
            } else if (!empty($user[0]->parent) && !empty($user[0]->is_virtual_account)) {
                $this->user_id = $user[0]->parent;
                $this->teamId = $user[0]->id;
            } else {
                $this->user_id = $user[0]->id;

            }

        } else {
            $this->adi->_response($verify_token);
            die();
        }

    }

    public function createProject()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $id = $postData->id;
            $InputArr = $postData->InputVar;
            $campaignName = $postData->campaignName;

            $prompts = $this->DatabaseModel->fetchTableData('task', array('id' => $id));
            $str = $prompts[0]->promts;
            if (!empty($InputArr)) {
                $outputArray = array();
                foreach ($InputArr as $object) {
                    foreach ($object as $key => $value) {
                        $outputArray["[$key]"] = $value;
                    }
                }

                foreach ($outputArray as $key => $val) {
                    $str = str_replace($key, $val, $str);
                }
            }

            $this->messageArray[] = array(
                'role' => 'system',
                'content' => $str,
            );

            $result = $this->openai->generateContentGPT($this->messageArray, $this->user_id, 'article');
            if ($result['status']) {
                $insert['orginalContent'] = $result['original'];
                $insert['userId'] = $this->user_id;
                $insert['campaignName'] = $campaignName;
                $insert['task'] = $prompts[0]->promptsName;
                $insert['taskId'] = $prompts[0]->id;
                $insert['prompts'] = $prompts[0]->promts;
                $insert['categoryId'] = $prompts[0]->categoryId;
                $insert['data'] = json_encode($InputArr) ?? '';
                $insert['created'] = date('Y-m-d H:i:s');
                $res = $this->DatabaseModel->insertData('projects', $insert);
                if ($res) {
                    $response = array('status' => true, 'data' => $res);
                } else {
                    $response = array('status' => false, 'message' => 'Project not created.');
                }

            } else {
                $response = array('status' => false, 'message' => 'Project not generated.');
            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid json.');
        }
        $this->adi->_response($response);
    }

    public function fetchProject()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $id = $postData->id;
            $res = $this->DatabaseModel->fetchTableData('projects', array('id' => $id, 'userId' => $this->user_id));

            if ($res) {
                $res[0]->data = json_decode($res[0]->data);

                $response = array('status' => true, 'data' => $res);
            } else {
                $response = array('status' => false, 'message' => 'Project not found.');
            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid json.');
        }
        $this->adi->_response($response);
    }

    public function updateProject()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $id = $postData->id;
            $update['data'] = json_encode($postData->data);
            $update['orginalContent'] = $postData->orginalContent;
            $update['modified'] = date('Y-m-d H:i:s');
            $res = $this->DatabaseModel->updateTable('projects', $update, array('id' => $id));
            if ($res) {
                $response = array('status' => true, 'message' => 'Project save.');
            } else {
                $response = array('status' => false, 'message' => 'Project not save.');

            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid json.');
        }
        $this->adi->_response($response);
    }

    public function generateScript()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $id = $postData->id;
            $cId = $postData->cId;
            $InputArr = $postData->InputVar;
            $prompts = $this->DatabaseModel->fetchTableData('task', array('id' => $id));
            $str = $prompts[0]->promts;
            if (!empty($InputArr)) {
                $outputArray = array();
                foreach ($InputArr as $object) {
                    foreach ($object as $key => $value) {
                        $outputArray["[$key]"] = $value;
                    }
                }

                foreach ($outputArray as $key => $val) {
                    $str = str_replace($key, $val, $str);
                }
            }

            $this->messageArray[] = array(
                'role' => 'system',
                'content' => $str,
            );

            $result = $this->openai->generateContentGPT($this->messageArray, $this->user_id, 'article');
            if ($result['status']) {
                $update['orginalContent'] = $result['original'];
                $update['data'] = json_encode($InputArr) ?? '';
                $update['modified'] = date('Y-m-d H:i:s');
                $resultData = $this->DatabaseModel->updateTable('projects', $update, array('id' => $cId));
                if ($resultData) {
                    $response = array('status' => true, 'data' => $result['data']);
                } else {
                    $response = array('status' => false, 'message' => 'Project not created.');
                }

            } else {
                $response = array('status' => false, 'message' => 'Scripts not generated.');
            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid json.');
        }
        $this->adi->_response($response);
    }

    public function fetchAllProject()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $start = $postData->start;
            $end = $postData->end;

            if ($start == 1) {
                $start = 0;
                $end = $end;
            } else {
                $start = ($start - 1) * $end;
                $end = $end;
            }
            $where['userId'] = $this->user_id;
            $where['isDeleted'] = 0;

            $totalProjects = $this->DatabaseModel->getCount('projects', $where);
            $res = $this->DatabaseModel->fetchalldata('projects', $where, $start, $end);

            if ($res) {
                foreach ($res as $key => $value) {
                    $res[$key]->data = json_decode($value->data);
                }

                $response = array('status' => true, 'data' => array('projects' => $res, 'totalProjects' => $totalProjects));
            } else {
                $response = array('status' => false, 'message' => 'Project not found.');

            }
        } else {
            $response = array('status' => false, 'message' => 'Invaid json data.');
        }
        $this->adi->_response($response);
    }
    public function deleteProject()
    {
        $jsonData = file_get_contents("php://input");
        $postData = $this->adi->isValidJson($jsonData);
        if ($postData) {
            $update['userId'] = $this->user_id;
            $update['isDeleted'] = 1;
            $where['id'] = $postData->id;
            $res = $this->DatabaseModel->updateTable('projects', $update, $where);
            if ($res) {
                $response = array('status' => true, 'message' => 'Project deleted successfully.');
            } else {
                $response = array('status' => false, 'message' => 'Project not deleted.');

            }

        } else {
            $response = array('status' => false, 'message' => 'Project not found.');

        }
        $this->adi->_response($response);
    }

}
