<?php
date_default_timezone_set("Asia/Calcutta");

use TBETool\PasswordGenerator;

/**
 * @property DatabaseModel DatabaseModel
 * @property CI_Email email
 */

class SuperAdminController extends CI_Controller
{

    private $secret_key = '(H+MbQeShVmYq3t6';
    public function __construct()
    {
        parent::__construct();
        $this->load->model('DatabaseModel');
    }

    public function fetchUsers()
    {
        $json_data = file_get_contents("php://input");
        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $get_key = $check_response->secret_key;

                if (!empty($get_key)) {

                    if ($this->secret_key == $get_key) {
                        $totalUsers = $this->DatabaseModel->fetchTableData('users');
                        $activeUsers = $this->DatabaseModel->fetchTableData('users', array('status' => 1));
                        $disableUsers = $this->DatabaseModel->fetchTableData('users', array('status' => 0));
                        $clientUsers = $this->DatabaseModel->fetchTableData('users', array('isClient' => 1));
                        $teamUsers = $this->DatabaseModel->fetchTableData('users', array('is_virtual_account' => 1));
                        $total_social_accounts = $this->DatabaseModel->fetchTableData('integrations');
                        $membership_levels = $this->DatabaseModel->fetchTableData('membership_levels');
                        if (!empty($membership_levels)) {
                            $membershiparr = array();
                            foreach ($membership_levels as $key => $level) {
                                $dataArr = array(
                                    'id' => $level->id,
                                    'title' => $level->title,
                                    'name' => $level->name,
                                );

                                $membershiparr[] = $dataArr;
                            }
                        }

                        if (!empty($totalUsers)) {
                            $responseArray = array();
                            foreach ($totalUsers as $key => $users) {
                                // dd($users);
                                $profile = 'https://backend.doitall.ai/assets/images/default.png';
                                if ($users->image != null and
                                    file_exists(FCPATH . 'assets/images/profiles/' . $users->id . '/' . $users->image)) {
                                    $profile = 'https://backend.doitall.ai/assets/images/profiles/' . $users->id . '/' . $users->image;

                                }
                                $user_type = 2;
                                if ($users->isClient == 1) {
                                    $user_type = 4;
                                } elseif ($users->is_virtual_account == 1) {
                                    $user_type = 3;
                                } elseif ($users->is_super_admin == 1) {
                                    $user_type = 1;
                                }

                                $data = array(
                                    'id' => $users->id,
                                    'name' => $users->name,
                                    'email' => $users->email,
                                    'profile_image' => $profile,
                                    'register_by' => $users->registered_by,
                                    'type' => $users->membership,
                                    'isClient' => $users->isClient,
                                    'is_virtual_account' => $users->is_virtual_account,
                                    'status' => $users->status,
                                    'is_admin' => $users->is_super_admin,
                                    'deleted' => $users->deleted,
                                    'created' => $users->created,
                                    'parent' => $users->parent,
                                    'modified' => $users->created,
                                    'user_id' => $users->id,
                                    'user_type' => $user_type,
                                    'is_email' => $users->is_email,
                                    'is_suspend' => $users->is_suspend,
                                    'suspend_reason' => $users->suspend_reason,
                                );

                                $responseArray[] = $data;
                                // dd($data);
                            }

                            $response['status'] = true;
                            $response['data']['users'] = $responseArray;
                            $response['data']['total_users'] = count($totalUsers);
                            $response['data']['active_users'] = count($activeUsers);
                            $response['data']['disabled_users'] = count($disableUsers) ? count($disableUsers) : 0;
                            $response['data']['client_users'] = count($clientUsers);
                            $response['data']['team_users'] = count($teamUsers);
                            $response['data']['social_accounts'] = count($total_social_accounts);
                            $response['data']['integrations'] = 0;
                            $response['data']['membership_levels'] = array_reverse($membership_levels);

                        } else {
                            $response['status'] = false;
                            $response['message'] = 'No Users data found';
                        }

                    } else {
                        $response['status'] = false;
                        $response['message'] = 'Invalid secret key';
                    }

                } else {
                    $response['status'] = false;
                    $response['message'] = 'Empty Secret Key';
                }

            } else {
                $response['status'] = false;
                $response['message'] = 'Invalid JSON Data';
            }

        } else {
            $response['status'] = false;
            $response['message'] = 'Empty JSON Data';
        }
        $this->adi->_response($response, $users->id);die;
    }

    public function addUser()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $name = $check_response->name;
                $email = $check_response->email;
                $password = $check_response->password;
                $user_type = $check_response->user_type;
                $get_keys = $check_response->secret_key;

                if (!empty($name) and !empty($email) and !empty($password) and !empty($get_keys)) {

                    if ($this->secret_key == $get_keys) {

                        /**
                         * Check user is disable or deleted
                         */
                        $checkuserisdelete = $this->DatabaseModel->exists('users', array('email' => $email, 'deleted' => 1));
                        if ($checkuserisdelete) {
                            $data['status'] = false;
                            $data['message'] = 'Requested user already exists and marked as deleted';
                            echo json_encode($data);
                            die();
                        }

                        $checkuserisdisable = $this->DatabaseModel->exists('users', array('email' => $email, 'status' => 0));

                        if ($checkuserisdisable) {
                            $data['status'] = false;
                            $data['message'] = 'Requested user already exists and marked as disable';
                            echo json_encode($data);
                            die();
                        }

                        $Password_hash = password_hash($password, PASSWORD_DEFAULT);

                        /**
                         * Check User exists or not
                         */
                        if (!$this->DatabaseModel->exists('users', array('email' => $email))) {

                            $data_arr = array(
                                'name' => $name,
                                'email' => $email,
                                'password' => $Password_hash,
                                'status' => 1,
                                'image' => base_url() . 'assets/images/default.png',
                                'registered_by' => 'Super Admin',
                                'created' => date('Y-m-d H:i:s'),
                            );

                            /** Check user account type */
                            if ($user_type == 1) {
                                $data_arr['is_super_admin'] = 1;
                            } elseif ($user_type == 3) {
                                $data_arr['is_virtual_account'] = 1;
                            } elseif ($user_type == 4) {
                                $data_arr['isClient'] = 1;
                            }
                            // dd($check_response);

                            /** Add users membership levels */
                            $type = $check_response->membership;

                            if (in_array("fastpass", $type)) {
                                $data_arr['membership'] = "premium__unlimited__unlimited-lite__plus__plus-lite__expansion__enterprise__bundle";

                            }

                            if (in_array("bundle", $type)) {
                                $data_arr['membership'] = "premium__unlimited__unlimited-lite__plus__plus-lite__expansion__enterprise__bundle";
                                $this->adi->_createKoincartAccount($data_arr, 'commercial');
                                $this->adi->_createContentReelAccount($data_arr, 'premium');
                                $this->adi->_createClickAgencyAccount($data_arr, 'professional');

                            } else {
                                if ((count($type)) == 1) {
                                    $account_type = $type[0];
                                    $data_arr['membership'] = $account_type;
                                } else {
                                    $account_type = implode("__", $type);
                                    $data_arr['membership'] = $account_type;
                                }
                            }

                            if ($id = $this->DatabaseModel->insertData('users', $data_arr)) {

                                /* Send Email for register user
                                 */

                                if ($check_response->email == true) {
                                    $d = array('username' => $check_response->email, 'password' => $check_response->password);
                                    $body = $this->load->view('welcome_mail', $d, true);
                                    $this->mailer->send_mail($email, 'Registered', $body);
                                }

                                /**
                                 * Add Email to GR
                                 */
                                if ($check_response->email == true) {
                                    $this->curl_post_request($name, $email);
                                }

                                /** Return Users Data in Response */
                                $totalUsers = $this->DatabaseModel->fetchTableData('users');
                                $active_users = $this->DatabaseModel->getCount('users', array('status' => 1));
                                $disable_users = $this->DatabaseModel->getCount('users', array('status' => 0));

                                if (!empty($totalUsers)) {

                                    $responseArray = array();
                                    foreach ($totalUsers as $users) {

                                        $data = array(
                                            'name' => $users->name,
                                            'email' => $users->email,
                                            'image' => $users->image,
                                            'register_by' => $users->registered_by,
                                            'type' => $users->membership,
                                            'isClient' => $users->isClient,
                                            'is_virtual_account' => $users->is_virtual_account,
                                            'status' => $users->status,
                                            'is_admin' => $users->is_super_admin,
                                            'deleted' => $users->deleted,
                                            'created' => $users->created,
                                            'parent' => $users->parent,
                                            'modified' => $users->created,
                                            'user_id' => $users->id,
                                            'user_type' => $user_type,
                                            'is_email' => $users->is_email,
                                        );

                                        $tmp_arr['user_type'] = 2;
                                        if ($users->isClient == 1) {
                                            $tmp_arr['user_type'] = 4;
                                        } elseif ($users->is_virtual_account == 1) {
                                            $tmp_arr['user_type'] = 3;
                                        } elseif ($users->is_super_admin == 1) {
                                            $tmp_arr['user_type'] = 1;
                                        }

                                        $responseArray[] = $data;
                                    }
                                }
                                $data['status'] = true;
                                $data['data']['users'] = $responseArray;
                                $data['data']['total_users'] = count($totalUsers);
                                $data['data']['active_users'] = $active_users;
                                $data['data']['disabled_users'] = $disable_users;
                                $data['message'] = 'Requested user created successfully';

                            } else {
                                $data['status'] = false;
                                $data['message'] = 'No records found!';
                            }
                        } else {
                            $data['status'] = false;
                            $data['message'] = 'User Already Exists';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;

    }

    public function fetchUser()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {
                $user_id = $check_response->id;
                $get_key = $check_response->secret_key;
                if (!empty($user_id) and !empty($get_key)) {

                    if ($this->secret_key == $get_key) {

                        $user = $this->DatabaseModel->fetchTableData('users', array('id' => $user_id));

                        if (!empty($user)) {

                            $responseArray = array();
                            foreach ($user as $value) {
                                // dd($value);
                                $tmp_arr = array(
                                    'name' => $value->name,
                                    'email' => $value->email,
                                    'image' => $value->image,
                                    'register_by' => $value->registered_by,
                                    'account_tag' => '',
                                    'account_type' => $value->membership,
                                    'isClient' => $value->isClient,
                                    'is_virtual_account' => $value->is_virtual_account,
                                    'status' => $value->status,
                                    'is_trial' => '',
                                    'deleted' => $value->deleted,
                                    'created' => $value->created,
                                    'user_id' => $value->id,
                                    'is_suspend' => $value->is_suspend,
                                    'suspend_reason' => $value->suspend_reason,
                                    'parent' => $this->DatabaseModel->fetchTableData('users', $value->parent),
                                    'login-logs' => $this->DatabaseModel->fetchTableData('user_logs', array('userid' => $user_id)),
                                    'user-activities' => $this->DatabaseModel->fetchTableData('user_activities', array('user_id' => $user_id)),
                                );

                                $tmp_arr['account_tag'] = 2;
                                // dd($tmp_arr);
                                if ($value->isClient == 1) {
                                    $tmp_arr['account_tag'] = 4;
                                } elseif ($value->is_virtual_account == 1) {
                                    $tmp_arr['account_tag'] = 3;
                                } elseif ($value->is_super_admin == 1) {
                                    $tmp_arr['account_tag'] = 1;
                                }

                                $responseArray[] = $tmp_arr;
                            }

                            $data['status'] = true;
                            $data['data'] = $responseArray;

                        } else {
                            $data['status'] = false;
                            $data['message'] = 'No records found';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;
    }

    public function fetchUserCampaign()
    {
        $queryString = file_get_contents("php://input");
        $check_response = $this->isValidJSON($queryString);
        $getSecretKey = $check_response->secret_key;
        $user_id = $check_response->user_id;
        $start = $check_response->pageno;
        $end = $check_response->limit;
        if ($getSecretKey == $this->secret_key) {

            $response['status'] = true;
            $response['data']['campaigns'] = [];

            /**
             * Social Account not Available pass blank array
             */
            $total_socials = $this->DatabaseModel->fetchalldata('integrations', array('userId' => $user_id, 'isDeleted' => 0), $start, $end);
            $totalSocial = $this->DatabaseModel->fetchTableData('integrations', array('userId' => $user_id, 'isDeleted' => 0));

            $response['data']['social_account'] = array();

            if (!empty($total_socials)) {
                $responseAccounts = array();
                foreach ($total_socials as $key => $value) {
                    $social_data = array(
                        'id' => $value->id,
                        'userId' => $value->userId,
                        'name' => $value->name,
                        'social' => $value->social,
                        'isDeleted' => $value->isDeleted,
                        'status' => $value->status,
                        'created' => $value->created,
                    );

                    $responseAccounts[] = $social_data;
                }

                $response['data']['social_account'] = $responseAccounts;
                $response['data']['socialLength'] = count($totalSocial);

            }

            /**
             * Fetch Client Account
             */

            $total_users = $this->DatabaseModel->fetchalldata('users', array('isClient' => 1, 'parent' => $user_id, 'deleted' => 0), $start, $end);

            $totalUser = $this->DatabaseModel->fetchTableData('users', array('isClient' => 1, 'parent' => $user_id, 'deleted' => 0));

            $response['data']['clients'] = array();
            if (!empty($total_users)) {
                $responseClient = array();
                foreach ($total_users as $key => $value) {
                    $client_data = array(
                        'id' => $value->id,
                        'name' => $value->name,
                        'email' => $value->email,
                        'parent' => $value->parent,
                        'registered_by' => $value->registered_by,
                        'account_tag' => $value->account_tag,
                        'isClient' => $value->isClient,
                        'status' => $value->status,
                        'deleted' => $value->deleted,
                        'created' => $value->created,
                    );

                    $responseClient[] = $client_data;
                }

                $response['data']['clients'] = $responseClient;
                $response['data']['clientLength'] = count($totalUser);

            }

            /**
             * Fetch Team Members
             */

            $totalTeam = $this->DatabaseModel->fetchTableData('users', array('is_virtual_account' => 1, 'parent' => $user_id, 'deleted' => 0));

            $response['data']['teams'] = array();
            if (!empty($totalTeam)) {
                $responseTeam = array();
                foreach ($totalTeam as $key => $value) {
                    $team_data = array(
                        'id' => $value->id,
                        'first_name' => $value->name,
                        'email' => $value->email,
                        'parent' => $value->parent,
                        'registered_by' => $value->registered_by,
                        'is_virtual_account' => $value->is_virtual_account,
                        'status' => $value->status,
                        'deleted' => $value->deleted,
                        'created' => $value->created,
                    );

                    array_push($responseTeam, $team_data);
                }
                $response['data']['teams'] = $responseTeam;
                $response['data']['teamLength'] = count($totalTeam);

            }

            /**
             * Fetch User login logs
             */
            $total_logs = $this->DatabaseModel->fetchalldata('user_logs', array('userid' => $user_id), $start, $end);
            $logs = $this->DatabaseModel->fetchTableData('user_logs', array('userid' => $user_id));

            $response['data']['user_logs'] = array();
            if (!empty($total_logs)) {
                $responseLogs = array();
                foreach ($total_logs as $key => $log) {

                    $log_data = array(
                        'id' => $log->id,
                        'login' => $log->login_at,
                        'logout' => $log->logout_at,
                        'client_ip' => $log->ip_address,
                    );

                    $responseLogs[] = $log_data;
                }
                $response['data']['login_logs'] = $responseLogs;
                $response['data']['loginLength'] = count($logs);

            }

            /**
             * Fetch User Activity Logs
             */
            $total_activity = $this->DatabaseModel->fetchalldata('user_activities', array('user_id' => $user_id), $start, $end);
            $totalactivity = $this->DatabaseModel->fetchTableData('user_activities', array('user_id' => $user_id));

            $response['data']['activity_logs'] = array();
            if (!empty($total_activity)) {
                $responseActivity = array();
                foreach ($total_activity as $key => $value) {
                    $activity_data = array(
                        'id' => $value->id,
                        'controller' => $value->controller,
                        'function' => $value->function,
                        'url' => $value->url,
                        'ip_address' => $value->ip,
                        'request_type' => $value->request_type,
                        'browser' => $value->browser,
                        'platform' => $value->platform,
                        'info' => $value->info,
                        'created' => $value->created,
                    );

                    $responseActivity[] = $activity_data;
                }
                $response['data']['activity_logs'] = $responseActivity;
                $response['data']['activityLength'] = count($totalactivity);

            }

        } else {
            $response['message'] = 'Secret Key is missing or invalid';
        }
        $this->adi->_response($response);die;

    }

    public function deleteUser()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $user_id = $check_response->id;
                $get_key = $check_response->secret_key;
                $deleted = $check_response->deleted;
                $reason = $check_response->reason;

                if (!empty($user_id) and !empty($get_key)) {

                    if ($this->secret_key == $get_key) {
                        if ($deleted == 1) {
                            $res = $this->DatabaseModel->updateTable('users', array('deleted' => $deleted, 'delete_reason' => $reason, 'undelete_reason' => ''), array('id' => $user_id));
                            $users = $this->DatabaseModel->fetchTableData('users', array('id' => $user_id));
                            $this->mailer->delete_account_send_mail($users[0]->email, $users[0]->name);
                            $this->DatabaseModel->updateTable('tokens', array('deleted' => 1), array('user_id' => $user_id));
                            $message = 'Account deleted';
                        } else {
                            $res = $this->DatabaseModel->updateTable('users', array('deleted' => $deleted, 'undelete_reason' => $reason, 'delete_reason' => ''), array('id' => $user_id));
                            $message = 'Account Enable';
                        }

                        if ($res) {
                            $data = array('status' => true, 'message' => $message . ' Successfully');
                        } else {
                            $data = array('status' => false, 'message' => $message . ' not Successful');
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;

    }

    public function disableUser()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $user_id = $check_response->id;
                $get_key = $check_response->secret_key;
                $status = $check_response->status;
                $reason = $check_response->reason;

                if (!empty($user_id) and !empty($get_key)) {

                    if ($this->secret_key == $get_key) {
                        if ($status == 0) {
                            $res = $this->DatabaseModel->updateTable('users', array('status' => $status, 'deactivate_reason' => $reason, 'activate_reason' => ''), array('id' => $user_id));
                            $message = 'Account Disable';
                            $users = $this->DatabaseModel->fetchTableData('users', array('id' => $user_id));
                            $this->mailer->disable_account_send_mail($users[0]->email, $users[0]->name);
                            $this->DatabaseModel->updateTable('tokens', array('deleted' => 1), array('user_id' => $user_id));
                        } else {
                            $res = $this->DatabaseModel->updateTable('users', array('status' => $status, 'activate_reason' => $reason, 'deactivate_reason' => ''), array('id' => $user_id));
                            $message = 'Account Enable';
                        }
                        if ($res) {
                            $data = array('status' => true, 'message' => $message . ' Successfully');
                        } else {
                            $data = array('status' => false, 'message' => $message . ' not Successful');
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;

    }

    public function updatePassword()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $user_id = $check_response->id;
                $password = $check_response->password;
                $confirm_password = $check_response->confirm_password;
                $get_key = $check_response->secret_key;

                if (!empty($password) and !empty($confirm_password) and !empty($get_key) and !empty($user_id)) {

                    if ($this->secret_key == $get_key) {

                        if ($password == $confirm_password) {

                            $data_arr = array(
                                'password' => password_hash($password, PASSWORD_DEFAULT),
                            );

                            if ($this->DatabaseModel->updateTable('users', $data_arr, array('id' => $user_id))) {
                                $this->DatabaseModel->updateTable('tokens', array('deleted' => 1), array('user_id' => $user_id));
                                $data['status'] = true;
                                $data['message'] = 'Password updated Successfully';
                                $users = $this->DatabaseModel->fetchTableData('users', array('id' => $user_id));
                                $this->mailer->password_update($users[0]->email, $password);
                                $this->DatabaseModel->updateTable('tokens', array('deleted' => 1), array('user_id' => $user_id));

                            } else {
                                $data['status'] = false;
                                $data['message'] = 'Something went wrong, Please try again';
                            }

                        } else {
                            $data['status'] = false;
                            $data['message'] = 'Password did not matched';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;

    }

    public function updateEmail()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $user_id = $check_response->id;
                $email = $check_response->email;
                $get_key = $check_response->secret_key;

                if (!empty($user_id) and !empty($email) and !empty($get_key)) {

                    if ($this->secret_key == $get_key) {

                        if (!$this->DatabaseModel->fetchTableData('users', array('email' => $email))) {
                            $old_email = $this->DatabaseModel->getField('email', 'users', 'id', $user_id);
                            $name = $this->DatabaseModel->getField('name', 'users', 'id', $user_id);
                            if ($this->DatabaseModel->updateTable('users', array('email' => $email), array('id' => $user_id))) {
                                $this->DatabaseModel->updateTable('tokens', array('deleted' => 1), array('user_id' => $user_id));
                                $this->mailer->send_update_email(array($old_email, $email), $name);
                                $data['status'] = true;
                                $data['data'] = $email;
                                $data['message'] = 'Email Updated Successfully';

                            } else {
                                $data['status'] = false;
                                $data['message'] = 'Something went wrong, Please try again';
                            }

                        } else {
                            $data['status'] = false;
                            $data['message'] = 'Email Already Exists';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }
        $this->adi->_response($data);die;

    }

    public function checkUser()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $email = $check_response->email;
                $secret_key = $check_response->secret_key;

                if (!empty($email) and !empty($secret_key)) {

                    /**
                     * Check user is disable or deleted
                     */
                    $checkuserisdelete = $this->DatabaseModel->fetchTableData('users', array('email' => $email, 'deleted' => 1));
                    // dd($checkuserisdelete);
                    if ($checkuserisdelete) {
                        $data['status'] = false;
                        $data['message'] = 'Requested user already exists and marked as deleted';
                        echo json_encode($data);
                        die();
                    }

                    $checkuserisdisable = $this->DatabaseModel->fetchTableData('users', array('email' => $email, 'status' => 0));
                    // dd($checkuserisdisable);
                    if ($checkuserisdisable) {
                        $data['status'] = false;
                        $data['message'] = 'Requested user already exists and marked as disable';
                        echo json_encode($data);
                        die();
                    }

                    /**
                     * Check User Exists
                     */
                    $checkUser = $this->DatabaseModel->fetchTableData('users', array('email' => $email));
                    if (!empty($checkUser)) {

                        $responseArray = array();
                        foreach ($checkUser as $value) {
                            // dd($value);
                            $tmp_arr = array(
                                'name' => $value->name,
                                'email' => $value->email,
                                'image' => $value->image,
                                'register_by' => $value->registered_by,
                                'account_tag' => '',
                                'type' => $value->membership,
                                'isClient' => $value->isClient,
                                'is_virtual_account' => $value->is_virtual_account,
                                'status' => $value->status,
                                'is_trial' => '',
                                'deleted' => $value->deleted,
                                'created' => $value->created,
                                'user_id' => $value->id,
                            );

                            $responseArray[] = $tmp_arr;
                        }

                        $data['status'] = true;
                        $data['message'] = 'Requested user exists';
                        $data['data'] = $responseArray;

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Requested user not exists';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameter';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);die;
    }

    public function curl_post_request($name, $email)
    {
        $url = 'https://api.getresponse.com/v3/contacts';

        $get_response['name'] = $name;
        $get_response['email'] = $email;
        $get_response['dayOfCycle'] = '10';
        $get_response['campaign']['campaignId'] = 'MotMQ';

        $post = json_encode($get_response);

        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $post,
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'X-Auth-Token: api-key de9227f28c5208001f5c2a9a34e7c984',
            ),
        ));
        curl_exec($ch);
        curl_close($ch);
    }

    public function isValidJson($str)
    {
        if (json_decode($str) !== null && strlen($str) > 0) {
            return json_decode($str);
        } else {
            return false;
        }
    }

    public function updateUserDetails()
    {
        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $passwordGenerator = new PasswordGenerator();
                $password = $passwordGenerator->generate();

                $user_id = $check_response->id;
                $type = $check_response->membership;
                $user_type = $check_response->user_type;

                if (!empty($user_id) and !empty($type)) {

                    /** Check User Exists or Not */
                    if ($this->DatabaseModel->exists('users', array('id' => $user_id))) {
                        $User_update = $this->DatabaseModel->getData('users', array('id' => $user_id));
                        $arr = $User_update[0];

                        if (in_array("bundle", $type)) {
                            $data_arr['membership'] = "premium__unlimited__unlimited-lite__plus__plus-lite__expansion__enterprise__bundle";
                            $this->adi->_createKoincartAccount($arr, 'commercial');
                            $this->adi->_createContentReelAccount($arr, 'premium');
                            $this->adi->_createClickAgencyAccount($arr, 'professional');

                        } else {
                            if ((count($type)) == 1) {
                                $account_type = $type[0];
                                $data_arr['membership'] = $account_type;
                            } else {
                                $data_arr['membership'] = implode("__", $type);
                            }
                        }

                        $data_arr['name'] = $check_response->name;
                        /** Check user account type */
                        if ($user_type == 1) {
                            $data_arr['is_super_admin'] = 1;
                            $data_arr['is_virtual_account'] = 0;
                            $data_arr['isClient'] = 0;
                        } elseif ($user_type == 3) {
                            $data_arr['is_super_admin'] = 0;
                            $data_arr['is_virtual_account'] = 1;
                            $data_arr['isClient'] = 0;
                        } elseif ($user_type == 4) {
                            $data_arr['is_super_admin'] = 0;
                            $data_arr['is_virtual_account'] = 0;
                            $data_arr['isClient'] = 1;
                        } elseif ($user_type == 2) {
                            $data_arr['is_super_admin'] = 0;
                            $data_arr['is_virtual_account'] = 0;
                            $data_arr['isClient'] = 0;
                        }

                        if ($this->DatabaseModel->updateTable('users', $data_arr, array('id' => $user_id))) {

                            $data['id'] = $user_id;
                            $data['status'] = true;
                            $data['message'] = 'User details updated successfully';

                        } else {
                            $data['status'] = false;
                            $data['message'] = 'Something went wrong, Please try again';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Requested User not Exists';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        echo json_encode($data);
        die();
    }

    public function suspendUser()
    {

        $json_data = file_get_contents("php://input");

        if (isset($json_data) and !empty($json_data)) {

            $check_response = $this->isValidJson($json_data);
            if ($check_response != false) {

                $user_id = $check_response->id;
                $get_key = $check_response->secret_key;
                $is_suspend = $check_response->is_suspend;
                $reason = $check_response->reason;

                if (!empty($user_id) and !empty($get_key)) {

                    if ($this->secret_key == $get_key) {
                        $update_data = array(
                            'is_suspend' => $is_suspend,
                            'suspend_backend_reason' => $reason,
                            'suspend_reason' => ($is_suspend == 1) ? "Your Account has been suspended due to suspicious activity. Please contact support for assistance." : "",
                        );

                        if ($is_suspend == 0) {
                            $this->DatabaseModel->updateTable('users', $update_data, array('id' => $user_id));
                            $data['status'] = true;
                            $data['message'] = 'Account Unsuspended Successfully';
                        } else {
                            $this->DatabaseModel->updateTable('users', $update_data, array('id' => $user_id));
                            $data['status'] = true;
                            $data['message'] = 'Account Suspended Successfully';
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Invalid Secret Key';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = 'Missing Required Parameters';
                }

            } else {
                $data['status'] = false;
                $data['message'] = 'Invalid JSON Data';
            }

        } else {
            $data['status'] = false;
            $data['message'] = 'Empty JSON Data';
        }

        $this->adi->_response($data);
    }

    public function filter_data()
    {
        $queryString = file_get_contents("php://input");
        if (isset($queryString)) {

            $check_response = $this->adi->isValidJSON($queryString);
            if ($check_response != false) {

                $getSecretKey = $check_response->secret_key;
                $start_date = $check_response->start_date;
                $end_date = $check_response->end_date;
                $type = $check_response->type;

                if ($getSecretKey == $this->secret_key) {

                    if (!empty($start_date) and !empty($end_date)) {

                        $data_user = $this->DatabaseModel->getFilterDate($start_date,
                            $end_date, $type);

                        if (!empty($data_user)) {

                            $data['status'] = true;
                            $data['message'] = "Data Found Successfully";
                            $data['data'] = $data_user;

                        } else {
                            $data['status'] = false;
                            $data['message'] = $type . " data not found";
                        }

                    } else {
                        $data['status'] = false;
                        $data['message'] = 'Missing Required Parameters';
                    }

                } else {
                    $data['status'] = false;
                    $data['message'] = "Invalid Secret Key";
                }

            } else {
                $data['status'] = false;
                $data['message'] = "Invalid JSON Data";
            }

        } else {
            $data['status'] = false;
            $data['message'] = "Empty JSON Data";
        }
        echo json_encode($data);
        die();
    }

    public function suspected_users()
    {
        $suspectedUsers = array();
        $all_users = $this->UserModel->fetchTableData('users', array('status' => 1));
        foreach ($all_users as $key => $user) {
            if (strpos($user->email, '@vega6.com') == true || strpos($user->email, '@doitall.ai') == true || $user->email == 'yourgreenscreenguy@gmail.com') {
                continue;
            } else {
                $user_logs = $this->UserModel->fetchdataGroupBy('user_logs', array('user_id' => $user->id), false, array('client_ip'));

                if (is_array($user_logs) && count($user_logs) > 3) {

                    $city_array = array();
                    $country_array = array();

                    foreach ($user_logs as $key_log => $logs) {
                        $ip = $logs->ip_address;
                        $user_id = $logs->user_id;
                        $email = $user->email;
                        $ip_location = $this->curl_post_request_search_ip($ip, $user_id, $email);
                        if (!empty($ip_location)) {
                            if (property_exists($ip_location, 'data')) {
                                $data = $ip_location->data;
                                $ip_data = json_decode($data->data, true);

                                if (($ip_data['country_name'] == "India") || ($ip_data['country_name'] == "Philippines")) {
                                    continue;
                                } else {
                                    $city_array[] = $ip_data['city'];
                                    $country_array[] = $ip_data['country_name'];
                                }
                            } else {
                                continue;
                            }
                        } else {
                            continue;
                        }
                    }
                    $country_array_unique = array_unique($country_array);
                    $city_array_unique = array_unique($city_array);

                    if ((count($country_array_unique) > 3) || (count($city_array_unique) > 5) || in_array('Pakistan', $country_array_unique)) {
                        array_push($suspectedUsers, $user);
                        $response = array(
                            'msg' => 'Suspected users found Successfully',
                            'data' => $suspectedUsers,
                            'status' => true,
                        );
                    } else {
                        continue;
                    }
                } else {
                    continue;
                }
            }

        }
        echo json_encode($response);die();
    }

    public function curl_post_request_search_ip($ip, $user_id, $email)
    {
        $url = "https://resources.vega6.info/search-ip";
        $access_token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJpYXQiOjE1ODY0MzU5NTEsImp0aSI6Ilg3MHd4bWJKQ3VVWGhEbzdSMHEwSmkiLCJpc3MiOiJodHRwczpcL1wvcmVzb3VyY2VzLnZlZ2E2LmluZm9cLyIsIm5iZiI6MTU4NjQzNTk2MSwiZGF0YSI6eyJ1c2VyX2lkIjoiMSIsImFwcF91cmwiOiJodHRwczpcL1wvYXBwLnN0b3J5cmVlbC5pbyJ9fQ.zAG4s-Utw8tjKWBtsivZSHt7-ssJwENJYYbZtdHtMRQLz1wCa856zuBJp0ULdHLHNXE8kr19n_YC8b72NLg1fQ';
        $get_response['user_id'] = $user_id;
        $get_response['email'] = $email;
        $get_response['ip'] = $ip;
        $post = json_encode($get_response);

        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $post,
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'Authorization: Bearer ' . $access_token,
            ),
        ));
        $response = curl_exec($ch);
        curl_close($ch);
        return json_decode($response);
    }

    public function createBulkAccount()
    {

        $json_data = file_get_contents("php://input");
        if ($post_data = $this->adi->isValidJSON($json_data)) {
            $allEmails = $post_data->email;
            $password = $post_data->password;
            $membership = $post_data->membership;
            $send_email = $post_data->send_email;
            $send_gr_email = $post_data->send_gr_email;
            $user_type = $post_data->user_type;
            $get_key = $post_data->secret_key;
            $password = $password ? $password : $this->adi->randomPassword();
            if ($this->secret_key == $get_key) {
                if ($user_type == 'Super Admin') {
                    $insert['is_super_admin'] = 1;
                } else if ($user_type == 'Virtual') {
                    $insert['is_virtual_account'] = 1;
                } else if ($user_type == 'client') {
                    $insert['is_client_account'] = 1;
                }
                $emails = explode(',', $allEmails);
                $count = 0;
                $Em = array();
                foreach ($emails as $email) {
                    $res = $result = $this->DatabaseModel->exists('users', array('email' => $email, 'deleted' => 0));
                    if ($res) {
                        array_push($Em, $email);
                        $count++;
                    }
                }
                if (!$count) {

                    foreach ($emails as $email) {
                        $Password_hash = password_hash($password, PASSWORD_DEFAULT);
                        $name = explode('@', $email);
                        $insert['name'] = $name[0];
                        $insert['email'] = $email;
                        $insert['password'] = $Password_hash;
                        $insert['image'] = base_url() . 'assets/images/profile.png';
                        $insert['membership'] = implode("__", $membership);
                        $insert['status'] = 1;
                        $insert['registered_by'] = 'Super Admin';
                        $res = $this->DatabaseModel->insertData('users', $insert);
                        if ($res) {
                            $d = array('username' => $email, 'password' => $password);
                            $body = $this->load->view('welcome_mail', $d, true);
                            if ($send_email) {
                                $this->mailer->send_mail($email, '[IMPORTANT] Your DoitAll Account Details.', $body);
                            }
                            if ($send_gr_email) {
                                $this->adi->addGetResponse($name, $email);
                            }

                        }
                    }
                    if ($res) {
                        $response = array('status' => true, 'message' => 'Account created.');
                    } else {
                        $response = array('status' => false, 'message' => 'Account not created.');

                    }
                } else {
                    $response = array('status' => false, 'data' => $Em, 'message' => 'Given Emails  already added');
                }
            } else {
                $response = array('status' => false, 'message' => 'Invalid Secret Key.');

            }
        } else {
            $response = array('status' => false, 'message' => 'Invalid Json');
        }
        $this->adi->_response($response);
    }
}
