<?php
date_default_timezone_set("Asia/Calcutta");

class TaskController extends CI_Controller
{

    public function __construct()
    {

        parent::__construct();
        $verify_token = $this->jwt_verify->verify_token_2();
        if ($verify_token['status'] != false) {
            $this->user_id = $verify_token['data']['user_id'];

            $user = $this->DatabaseModel->fetchTableData('users', array('id' => $this->user_id));

            if (!empty($user[0]->parent) && !empty($user[0]->isClient)) {

                $this->clientId = $user[0]->id;
                $this->user_id = $user[0]->parent;
            } else if (!empty($user[0]->parent) && !empty($user[0]->is_virtual_account)) {
                $this->user_id = $user[0]->parent;
                $this->teamId = $user[0]->id;
            } else {
                $this->user_id = $user[0]->id;

            }

        } else {
            $this->adi->_response($verify_token);
            die();
        }

    }

    public function fetchPopularTask()
    {
        $json_data = file_get_contents("php://input");
        if ($post_data = $this->adi->isValidJSON($json_data)) {
            $task = $this->DatabaseModel->fetchTableData('task', array('status' => 1, 'isPopular' => 1));
            if ($task) {
                $response = array('status' => true, 'data' => $task);
            } else {
                $response = array('status' => false, 'message' => 'Data not found.');

            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid json.');
        }
        $this->adi->_response($response);
    }
    public function fetchAllTask()
    {
        $json_data = file_get_contents("php://input");
        if ($post_data = $this->adi->isValidJSON($json_data)) {
            $start = $post_data->start;
            $cattegoryId = $post_data->cattegoryId;
            $end = $post_data->end;

            if ($start == 1) {
                $start = 0;
                $end = $end;
            } else {
                $start = ($start - 1) * $end;
                $end = $end;
            }
            $popularTask = array();
            if ($cattegoryId != false) {
                $Task = $this->DatabaseModel->fetchalldata('task', array('status' => 1, 'categoryId' => $cattegoryId), $start, $end);
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->fetchTableData('task', array('status' => 1, 'categoryId' => $cattegoryId));

                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1, 'categoryId' => $cattegoryId));
                $newArr['totalProject'] = count($totaltask);
                $newArr['popularTask'] = $popularTask;
            } else {
                $Task = $this->DatabaseModel->fetchalldata('task', array('status' => 1), $start, $end);
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->fetchTableData('task', array('status' => 1));
                $newArr['totalProject'] = count($totaltask);
                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1));
                $newArr['popularTask'] = $popularTask;
            }

            if (!empty($Task)) {
                $response = array(
                    'status' => true,
                    'data' => $newArr,
                    'message' => 'Task found successfully.',
                );

            } else {
                $response = array('status' => false, 'message' => 'Task not found');
            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid jason');
        }
        $this->adi->_response($response, $this->user_id);

    }

    public function searchTask()
    {
        $json_data = file_get_contents("php://input");
        if ($post_data = $this->adi->isValidJSON($json_data)) {
            $cattegoryId = $post_data->cattegoryId;
            $keyword = $post_data->keyword;
            $popularTask = array();
            if ($cattegoryId != false && $keyword != '') {
                $Task = $this->DatabaseModel->fetchalldataWithlike('task', array('status' => 1, 'categoryId' => $cattegoryId), $keyword);
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->getCount('task', array('status' => 1, 'categoryId' => $cattegoryId), $keyword);

                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1, 'categoryId' => $cattegoryId), 4, $keyword);
                $newArr['totalProject'] = $totaltask;
                $newArr['popularTask'] = $popularTask;
            } elseif ($cattegoryId == false && $keyword != '') {
                $Task = $this->DatabaseModel->fetchalldataWithlike('task', array('status' => 1), $keyword);
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->getCount('task', array('status' => 1), $keyword);
                $newArr['totalProject'] = $totaltask;
                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1), 4, $keyword);
                $newArr['popularTask'] = $popularTask;
            } elseif ($cattegoryId != false && $keyword == '') {
                $Task = $this->DatabaseModel->fetchalldataWithlike('task', array('status' => 1, 'categoryId' => $cattegoryId));
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->getCount('task', array('status' => 1, 'categoryId' => $cattegoryId), '');
                $newArr['totalProject'] = $totaltask;
                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1, 'categoryId' => $cattegoryId), 4, '');
                $newArr['popularTask'] = $popularTask;
            } else {
                $Task = $this->DatabaseModel->fetchTableData('task', array('status' => 1));
                $newArr['task'] = $Task;
                $totaltask = $this->DatabaseModel->getCount('task', array('status' => 1), '');
                $newArr['totalProject'] = $totaltask;
                $popularTask = $this->DatabaseModel->getLimitRecords('task', array('status' => 1, 'isPopular' => 1), 4, '');
                $newArr['popularTask'] = $popularTask;
            }

            if (!empty($Task)) {
                $response = array(
                    'status' => true,
                    'data' => $newArr,
                    'message' => 'Task found successfully.',
                );

            } else {
                $response = array('status' => false, 'message' => 'Task not found');
            }

        } else {
            $response = array('status' => false, 'message' => 'Invalid jason');
        }
        $this->adi->_response($response, $this->user_id);

    }

}
