<?php

/**
 * @property CI_Controller $CI\
 * @property array $messageArray
 * @property $CI
 */
class Ai
{

    public function __construct()
    {
        $this->CI = &get_instance();
        $this->messageArray = array();
    }

    private function initContext($id)
    {
        $conversation = $this->CI->DatabaseModel->fetchTableData('conversation', array('id' => $id));
        if (!empty($conversation)) {
            $this->messageArray[] = array(
                'role' => 'system',
                'content' => $conversation[0]->system,
            );
        }
    }

    private function loadPreviewMessages($cid)
    {
        $messages = array_reverse($this->CI->DatabaseModel->fetchTableData('messages', array('cid' => $cid)));
        if (!empty($messages)) {
            foreach ($messages as $message) {
                $this->messageArray[] = array(
                    'role' => $message->type,
                    'content' => $message->messages,
                );
            }
        }
    }

    public function startMessage($messageArray)
    {
        $this->initContext($messageArray['cid']);
        $this->loadPreviewMessages($messageArray['cid']);
        //print_r($this->messageArray);
        $checkMessage = $this->CI->openai->generateContentGPT($this->messageArray, $messageArray['userId'], 'article');
        //print_r($checkMessage);
        if ($checkMessage['status']) {
            $sources = new stdClass();
            $sources->link = '';
            $sources->text = 'source';
            $insertMessage = array(
                'cid' => $messageArray['cid'],
                'userId' => $messageArray['userId'],
                'staffId' => $messageArray['staffId'],
                'hireId' => $messageArray['hireId'],
                'messages' => $checkMessage['original'],
                'sources' => json_encode($sources),
                'type' => 'assistant',
                'isDeleted' => 0,
                'created' => date('Y-m-d H:i:s'),
                'modified' => date('Y-m-d H:i:s'),
            );
            $checkInsert = $this->CI->DatabaseModel->insertData('messages', $insertMessage);
            if ($checkInsert) {
                $response = array(
                    'status' => true,
                    'message' => 'Message Sent',
                    'data' => $checkMessage['original'],
                );
            } else {
                $response = array(
                    'status' => false,
                    'message' => 'Message Not Sent',
                );
            }
        } else {
            $response = array(
                'status' => false,
                'message' => 'Error receiving message : ' . json_encode($checkMessage['message']),
            );
        }
        return $response;
    }

    public function startMessage_embed($messageArray)
    {
        $this->initContext($messageArray['staffId']);
        $this->loadPreviewMessages($messageArray['cid']);
        //print_r($this->messageArray);
        $checkMessage = $this->CI->openai->generateContentGPT($this->messageArray, $messageArray['userId'], 'article');
        //print_r($checkMessage);
        if ($checkMessage['status']) {
            $where2['userId'] = $messageArray['userId'];
            $where2['staffId'] = $messageArray['staffId'];
            if ($hiredStaff = $this->CI->DatabaseModel->fetchTableDataOrder('hire', $where2)) {
                $where['id'] = $messageArray['staffId'];
                $staff = $this->CI->DatabaseModel->fetchTableData('staff', $where);
                $message = str_replace($staff[0]->name, $hiredStaff[0]->hire_name, $checkMessage['original']);

            } else {
                $message = $checkMessage['original'];
            }

            $insertMessage = array(
                'userId' => $messageArray['userId'],
                'staffId' => $messageArray['staffId'],
                'messages' => $checkMessage['original'],
                'type' => 'assistant',
                'isDeleted' => 0,
                'created' => date('Y-m-d H:i:s'),
                'modified' => date('Y-m-d H:i:s'),
            );
            $checkInsert = $this->CI->DatabaseModel->insertData('messages', $insertMessage);
            if ($checkInsert) {
                $response = array(
                    'status' => true,
                    'message' => 'Message Sent',
                    'data' => $checkMessage['original'],
                );
            } else {
                $response = array(
                    'status' => false,
                    'message' => 'Message Not Sent',
                );
            }
        } else {
            $response = array(
                'status' => false,
                'message' => 'Error receiving message : ' . $checkMessage['message'],
            );
        }
        return $response;
    }

}
