<?php

class God_mode
{
    public function __construct()
    {
        $this->CI = &get_instance();
        $this->baseUrl = 'http://18.246.64.211:3000/api/agent/';
    }

    private function updateTable($table,$update,$condition)
    {
        $updateTable = $this->CI->DatabaseModel->updateTable($table,$update,$condition);
        if($updateTable)
        {
            return true;
        }
        else{
            return false;
        }
    }
    private function loadInsertArray($startArray){
        return  array(
            'userId' => $startArray['userId'],
            'staffId' => $startArray['staffId'],
            'hireId' => $startArray['hireId'],
            'cid' => $startArray['hireId'],
            'type' => $startArray['type']
        );
    }
    private function insertTable($table,$insert)
    {
        $updateTable = $this->CI->DatabaseModel->insertData($table,$insert);
        if($updateTable)
        {
            return $updateTable;
        }
        else{
            return false;
        }
    }

    private function callApi($type,$goal,$apiKey,$others){
        $url = $this->baseUrl.$type;
        $field = array();
        if($type == 'start')
        {
            $field = array(
                'goal' => $goal,
                'language' => 'English',
                'modelSettings' => array(
                    'customApiKey' => $apiKey,
                    'customMaxLoops' => 10,
                    'customModelName' => 'gpt-4',
                    'customTemperature' => 0.9,
                    'maxTokens' => 300
                )
            );
        }
        if($type == 'execute')
        {
            $field = array(
                'analysis' => array(
                    'action' => 'reason',
                    'arg' => ''
                ),
                'goal' => $goal,
                'language' => 'English',
                'modelSettings' => array(
                    'customApiKey' => $apiKey,
                    'customMaxLoops' => 10,
                    'customModelName' => 'gpt-4',
                    'customTemperature' => 0.9,
                    'maxTokens' => 300
                ),
                'task' => $others['task']
            );

        }
        if($type == 'create') {
            $field = array(
                'completedTasks' => $others['completedTasks'],
                'goal' => $goal,
                'language' => 'English',
                'lastTask' => $others['lastTask'],
                'modelSettings' => array(
                    'customApiKey' => $apiKey,
                    'customMaxLoops' => 10,
                    'customModelName' => 'gpt-4',
                    'customTemperature' => 0.9,
                    'maxTokens' => 300
                ),
                'result' => $others['result'],
                'tasks' => $others['pendingTasks']
            );
        }
        return $this->CI->adi->simple_curl_request(json_encode($field),$url,'POST');
    }

    public function start($startArray,$apiKey)
    {
        $others = array();
        $data = array('status' => false);
        $checkResponse = $this->callApi('start',$startArray['goal'],$apiKey,$others);
        //print_r($checkResponse);
        if(is_array($checkResponse->newTasks))
        {
            $tasks = array();
            foreach($checkResponse->newTasks as $key => $task)
            {
                $t = str_replace(array('{','}'),array('',''),$task);
                $insert = $this->loadInsertArray($startArray);
                $insert['gId'] = $startArray['gId'];
                $insert['task'] = $t;
                $insert['status'] = 0;
                $tid = $this->insertTable('gmResponseTask',$insert);
                $tasks[$key]['id'] = $tid;
                $tasks[$key]['task'] = $t;
            }
            $data['status'] = true;
            $data['message'] = 'found';
            $data['data']['tasks'] = $tasks;
        }
        else{
            $data['message'] = 'Something went wrong. Not able to start Goal.';
        }
        return $data;
    }

    public function execute($executeArray,$apiKey)
    {
        $others['task'] = $executeArray['task'];
        $data = array('status' => false);
        $checkResponse = $this->callApi('execute',$executeArray['goal'],$apiKey,$others);
        //print_r($checkResponse);
        if(isset($checkResponse->response)){
            $insert = $this->loadInsertArray($executeArray);
            $insert['gId'] = $executeArray['gId'];
            $insert['gtId'] = $executeArray['tid'];
            $insert['response'] = $checkResponse->response;
            $insert['status'] = 1;

            $checkInsert = $this->CI->DatabaseModel->insertData('gmResponseResponse',$insert);
            if($checkInsert)
            {
                $data['status'] = true;
                $data['message'] = 'found';
                $response['id'] = $checkInsert;
                $response['response'] = $checkResponse->response;
                $data['data'] = $response;
            }
        }
        else{
            $data['message'] = 'Something went wrong. Not able to execute Task.';
        }
        return $data;
    }

    public function create($createArray,$apiKey)
    {
        $others['completedTasks'] = $createArray['completedTasks'];
        $others['result'] = $createArray['result'];
        $others['pendingTasks'] = $createArray['pendingTasks'];
        $others['lastTask'] = $createArray['lastTask'];
        $data = array('status' => false);
        $checkResponse = $this->callApi('create',$createArray['goal'],$apiKey,$others);
        //print_r($checkResponse);
        if(is_array($checkResponse->newTasks)){
            $tasks = array();
            foreach($checkResponse->newTasks as $key => $task)
            {
                $insert = $this->loadInsertArray($createArray);
                $insert['gId'] = $createArray['gId'];
                $insert['task'] = $task;
                $insert['status'] = 0;
                $tid = $this->insertTable('gmResponseTask',$insert);
                $tasks[$key]['id'] = $tid;
                $tasks[$key]['task'] = $task;
            }

            $data['status'] = true;
            $data['message'] = 'found';
            $data['data'] = $tasks;
        }
        else{
            $data['message'] = 'Something went wrong. Not able to execute Task.';
        }
        return $data;
    }
}