<?php defined('BASEPATH') or exit('No direct script access allowed');
require "vendor/autoload.php";
use PHPMailer\PHPMailer\PHPMailer;

/**
 * @property string fromEmail
 * @property string fromName
 * @property string brand
 * @property string brandUrl
 * @property string host
 * @property string username
 * @property string password
 * @property int port
 * @property PHPMailer mail
 *
 */
class Mailer
{

    public function __construct()
    {
        $this->CI = &get_instance();
        $this->CI->load->model('DatabaseModel');
        $this->fromEmail = 'abhi@abhineos.com';
        $this->fromName = 'Abhi Dwivedi';
        $this->brand = APP_NAME;
        $this->brandUrl = FE_URL;

        $smtp_details = $this->CI->DatabaseModel->fetchTableData('smtp');

        $this->mail = new PHPMailer;
        $this->mail->isSMTP();
        $this->mail->Host = $smtp_details[0]->smtp_host;
        $this->mail->SMTPAuth = true;
        $this->mail->Username = $smtp_details[0]->smtp_user;
        $this->mail->Password = $smtp_details[0]->smtp_pass;
        $this->mail->Port = $smtp_details[0]->smtp_port;
        $this->mail->setFrom($this->fromEmail, $this->fromName);
        $this->mail->isHTML(true);

    }

    public function send_password_rest_mail($email, $link)
    {

        $body = "Hey,<br /><br />

		You had requested to reset your password. Please Click the <a href='$link'>Reset Password</a> to reset your password. <br /><br />

		You can also copy and paste this link in your browser to reset your password $link

		<br /><br />
		Reach out to us if you have any support queries: <a href='http://support.vineasx.com'>http://support.vineasx.com</a> <br />
		<br /><br />
		Cheers,<br />
		Abhi Dwivedi<br />
		" . $this->brand . " Team";

        $this->mail->addAddress($email, '');
        $this->mail->Subject = $this->brand . ' Password Reset';
        $this->mail->Body = $body;

        if ($this->mail->send()) {
            return true;
        } else {
            return false;
        }
    }

    public function delete_client_send_mail($email, $name)
    {

        $body = "Dear " . $name . ",<br /><br />


        We would like to inform you that your client account has been successfully deleted .<br /><br />
        If you encounter any issues or have any questions regarding your client account deletion, please do not hesitate to contact our support team at <a href='http://support.vineasx.com'>http://support.vineasx.com</a>. Our team will be happy to assist you and address any concerns you may have.
        <br /><br />
        We would like to take this opportunity to thank you for using our app as a client. We value your support and your feedback, and we are constantly working to improve our app to meet the needs of our users.
		<br /><br />
        Thank you again for using our app.<br /><br />

		Sincerely,<br /><br />
		" . $this->brand . " Team";

        $this->mail->addAddress($email, '');
        $this->mail->Subject = $this->brand . ' Client Account Deleted';
        $this->mail->Body = $body;

        if ($this->mail->send()) {
            return true;
        } else {
            return false;
        }
    }

    public function delete_account_send_mail($email, $name)
    {

        $body = "Dear " . $name . ",<br /><br />


        We would like to inform you that your account has been successfully deleted from our app. We apologize for any inconvenience this may have caused you.Please note that deleting your account means that all of your data and information have been permanently removed from our system. If you encounter any issues or have any questions regarding your account deletion, please do not hesitate to contact our support team at <a href='http://support.vineasx.com'>http://support.vineasx.com</a>. Our team will be happy to assist you and address any concerns you may have.";

        $this->mail->addAddress($email, '');
        $this->mail->Subject = $this->brand . ' User Deleted';
        $this->mail->Body = $body;

        if ($this->mail->send()) {
            return true;
        } else {
            return false;
        }
    }

    public function disable_account_send_mail($email, $name)
    {

        $body = "Dear " . $name . ",<br /><br />


        We would like to inform you that your account has been successfully disabled from our app.<br /><br />
        Please note that disabling your account means that your account is no longer accessible to other users, but your data and information are still stored in our system.
        <br /><br />
        If you encounter any issues or have any questions regarding your account disabling, please do not hesitate to contact our support team at <a href='http://support.vineasx.com'>http://support.vineasx.com</a>. Our team will be happy to assist you and address any concerns you may have.
		<br /><br />
        We value your support and your feedback, and we are constantly working to improve our app to meet the needs of our users.<br /><br />
        Thank you again for using our app.<br /><br />
		Sincerely,<br /><br />
		" . $this->brand . " Team";

        $this->mail->addAddress($email, '');
        $this->mail->Subject = $this->brand . ' Account Disabled';
        $this->mail->Body = $body;

        if ($this->mail->send()) {
            return true;
        } else {
            return false;
        }
    }

    public function send_update_email($emails, $name)
    {
        $body = "Hey " . $name . ",<br /><br />

    This is to inform you that your email address associated with your account has been updated successfully.
    We have recently received a request to update the email address in our system, and we have verified the request and updated your account accordingly. <br /><br />

    Please note that all future communications and notifications related to your account will be sent to your new email address. It is important that you keep your contact information up to date so that we can keep you informed about any changes or updates related to your account.

    <br /><br />
    If you did not initiate this update request, please contact us immediately at: <a href='http://support.vineasx.com'>http://support.vineasx.com</a> so that we can investigate the matter and ensure the security of your account. <br />
    <br /><br />
    Thank you for choosing our services. If you have any further questions or concerns, please do not hesitate to contact us.
    <br /><br />
    Best regards,<br /><br />
    " . $this->brand . " Team";

        $this->mail->Subject = $this->brand . ' Your Email Address Updated';
        $this->mail->Body = $body;

        foreach ($emails as $email) {
            $this->mail->addAddress($email, '');
            if (!$this->mail->send()) {
                // If an email fails to send, log the error and continue sending to the remaining emails
                error_log('Failed to send email to ' . $email . ': ' . $this->mail->ErrorInfo);
            }
            $this->mail->clearAddresses();
        }

        return true;
    }

    public function password_update($email, $password)
    {
        $body = "
        Hey,<br /><br />

        Your password for " . $this->brand . " has been changed.Please logout and login with the new password.

        <br /><br />
        Reach out to us if you have any support queries: <a href='http://support.vega6.com'>http://support.vega6.com</a> <br />
        <br /><br />
        Cheers,<br />
        Abhi Dwivedi<br />
        " . $this->brand . " Team

        ";

        $alt_body = "Hey,
        Your password for  " . $this->brand . " has been changed. Please logout and login with the new password.

        Reach out to us if you have any support queries: http://support.vineasx.com

        Cheers,
        Abhi Dwivedi
        " . $this->brand . " Team";
        $this->mail->addAddress($email, ''); // add a recipient
        $this->mail->Subject = $this->brand . ' Account Password Changed';
        $this->mail->Body = $body;
        $this->mail->AltBody = $alt_body;

        $check = $this->mail->send();
        if (!$check) {
            echo $mail->ErrorInfo;
        } else {
            return true;
        }
    }

    public function send_mail($email, $subject, $body, $app_name = '')
    {
        $app = ($app_name != '') ? $app_name : $this->brand;
        $this->mail->addAddress($email, '');
        $this->mail->Subject = $app . ' ' . $subject;
        $this->mail->Body = $body;
        if (!$this->mail->send()) {
            // If an email fails to send, log the error and continue sending to the remaining emails
            error_log('Failed to send email to ' . $email . ': ' . $this->mail->ErrorInfo);
        } else {
            $this->mail->clearAddresses();
            return true;
        }
    }

    public function sub_accounts($email, $password, $type)
    {
        $body = "
		Hey,<br /><br />

		You had been invited to use the $type account of " . $this->brandUrl . ";

		THESE ARE YOUR " . strtoupper($this->brand) . " ACCESS INSTRUCTIONS <br />
		Your User ID: $email <br />
		Your Password: $password <br />
		Login at: <a href='" . $this->brandUrl . "'>" . $this->brandUrl . "</a><br /><br />


		Use these access details to log in to the <a href='" . $this->brandUrl . "'>" . $this->brand . "</a> dashboard. Once you login to the dashboard, you will get access to the training and more inside.

		<br /><br />

		Please go through this two important training video to get started with " . $this->brand . " <br /><br />
		" . $this->brand . " Explainer Video: <a href='https://youtu.be/1Dhwr9ZBUJ'>https://youtu.be/1Dhwr9ZBUJ</a> <br />
		" . $this->brand . " Facebook Explainer Video: <a href='https://youtu.be/jNG3c3qzacs'>https://youtu.be/jNG3c3qzacs</a>
		<br /><br />
		Reach out to us if you have any support queries: <a href='http://support.vega6.com'>http://support.vega6.com</a> <br />
		<br /><br />
		Cheers,<br />
		Abhi Dwivedi<br />
		" . $this->brand . " Team
		";

        $alt_body = "Hey,

		Thank-you for your smart decision to invest in <a href='" . $this->brandUrl . "'>" . $this->brand . " $type</a>. We are so pumped to have you onboard as our VIP customer.

		THESE ARE YOUR " . strtoupper($this->brand) . " ACCESS INSTRUCTIONS
		Your User ID: $email
		Your Password: $password
		Login at: " . $this->brandUrl . "


		Use these access details to log in to the " . $this->brand . " dashboard. Once you login to the dashboard, you will get access to the training and more inside.


		Reach out to us if you have any support queries: http://support.vineasx.com

		Cheers,
		Abhi Dwivedi
		" . $this->brand . " Team";

        $this->mail->addAddress($email, '');
        $this->mail->Subject = $this->brand . ' Access Information';
        $this->mail->Body = $body;
        $this->mail->AltBody = $alt_body;

        $check = $this->mail->send();

        // $mailingAr['to'] = $email;
        // $mailingAr['subject'] = $this->brand.' Password Reset';
        // $mailingAr['html'] = $body;
        // $check = $mg->sendMessage($domain, $mailingAr);

        if (!$check) {
            //echo $mail->ErrorInfo;
            return false;
        } else {
            return true;
        }
    }

    public function upgrademail($email, $type)
    {
        $body = "
				Hey,<br /><br />

		We have Upgraded your " . $this->brand . " account to " . $this->brand . " $type.<br />
		You now have access to tons of new cutting edge features that you can access from inside your " . $this->brand . " dashboard.
		<br /><br />
		Please logout and login again to your " . $this->brand . " account here: <a href='" . $this->brandUrl . "'>" . $this->brandUrl . "</a>
		<br />

		Thank-you for your smart decision to invest in " . $this->brand . ". We are so pumped to have you onboard as our VIP customer.
		<br />
		If you face any issues accessing your purchase or account, please reach out to us at http://support.vega6.com
		<br /><br />

		Cheers,<br />
		Abhi Dwivedi<br />
		" . $this->brand . " Team

		";

        $alt_body = "		Hey,

		We have Upgraded your " . $this->brand . " account to " . $this->brand . " $type.
		You now have access to tons of new cutting edge features that you can access from inside your " . $this->brand . " dashboard.

		Please logout and login again to your " . $this->brand . " account here: <a href='" . $this->brandUrl . "'>" . $this->brandUrl . "</a>

		Thank-you for your smart decision to invest in " . $this->brand . ". We are so pumped to have you onboard as our VIP customer.

		If you face any issues accessing your purchase or account, please reach out to us at http://support.vineasx.com


		Cheers,
		Abhi Dwivedi
		" . $this->brand . " Team";

        $this->mail->addAddress($email, ''); // add a recipient

        $this->mail->Subject = $this->brand . ' UPGRADED';
        $this->mail->Body = $body;
        $this->mail->AltBody = $alt_body;

        $check = $this->mail->send();

        // $mailingAr['to'] = $email;
        // $mailingAr['subject'] = $this->brand.' Password Reset';
        // $mailingAr['html'] = $body;
        // $check = $mg->sendMessage($domain, $mailingAr);

        if (!$check) {
            //echo $mail->ErrorInfo;
            return false;
        } else {
            return true;
        }
    }

}
